import sys
import os
from pathlib import Path
from typing import Dict, Any
import requests

modules_path = '../../../modules/'
if os.path.exists(modules_path):
    sys.path.insert(1, modules_path)

import network_constants as nc
from security.token_manager import TokenManager

import tables.add_table as add_table

def add_use_case(use_case: str):
    jwt = TokenManager.getInstance().getToken()
    url = f"https://articonf1.itec.aau.at:30420/api/use-cases"
    response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = {"name": use_case}
        )
    
    print(url+": "+str(response.status_code))
        

if __name__ == "__main__":
    # TODO strategy pattern for all the use cases where add_use_case() etc. is clear duplicate code
    # The same for add table, where almost everything is the same (UniqueId, Timestamp for every Layer)
    # Only need to get jwt token once in the strategy impl
    use_case = "community-prediction-youtube"
    
    # disable ssl warnings :) 
    requests.packages.urllib3.disable_warnings() 

    add_use_case(use_case)
    add_table.main(use_case=use_case)